<template>
	<div>
		<el-dialog v-model="dialogVisible">
			<task-binder
				:item="selectedTask"
				@submit="handleTaskAssignSubmit"
				@close="handleTaskAssignClose"
			/>
		</el-dialog>
		<div class="toolbox">
			<div>
				<span>Clickup team:</span>
				<select-box :data="teamDataSelect" v-model="selectedTeam" />
			</div>
			<div>
				<span>Redmine activity:</span>
				<select-box
					:data="activityDataSelect"
					:model-value="selectedActivity"
					@update:model-value="changeActivity"
				/>
			</div>
			<el-affix ref="affix" :offset="buttonsOffset" position="top">
				<span class="buttons">
					<span class="btn-refresh">
						<el-button @click="handleRefresh">Refresh</el-button>
					</span>
					<span class="btn-save">
						<el-button type="primary" @click="handleSave">Save</el-button>
					</span>
				</span>
			</el-affix>
			<span>
				<date-week-control v-model="dateRange" />
			</span>
		</div>
		<div class="timesheet-days">
			<timesheet-day
				v-for="item of allTableData"
				:key="item.id"
				:item="item"
				:team-id="selectedTeam"
				:col-widths="[20]"
				@change-task-id="showDialog"
				@change-task-name="handleChangeTaskName"
				@refresh="handleRefresh"
			/>
		</div>
	</div>
</template>

<script setup lang="ts">
import DateWeekControl from "./controls/DateWeekControl.vue";
import TaskBinder from "./controls/TaskBinder.vue";
import { ElDialog, ElAffix, ElButton } from "element-plus";
import {
	getTimesheetsIterator,
	groupTimesheetsByDay,
	ifsUpdateTimesheets,
	loadAttendanceHours,
	loadEmployeeDayInfo,
	loadRedmineTimesheetItems,
	loadReportTimesheetItems,
	rmUpdateTimesheets,
	searchClickTasks,
	TimesheetType,
} from "./timesheet";
import SelectBox from "./controls/SelectBox.vue";
import { computed, onMounted, ref, watch } from "vue-demi";
import { ReportTimesheetItem, TimesheetDayItem, TimesheetDayState, TimesheetItem, TimesheetTask, UpdateRedmineTimesheetItem, UpdateReportTimesheetItem } from "../ts/types";
import { ClickTask, ClickTeam, ClickTimesheet, ClickTimesheetHours, ClickUser, IfsApiResponse, IfsEmployeeDayStatus, IfsTimesheetHours, RMApiActivity, RMApiTimesheetHours, Task, TaskEither, TE } from "../../lib/types";
import { apiResolveOrAlert, apiResolveOrDefault, resolveOrAlertMessage } from "../ts/utils/uiUtil";
import { addDuration, dateCompare, dateDaysIter, dateInInterval, dateIsSame, dateMinAndMax, DateRange, dateWeekRange, DurationTime, formatDateSql, getPositiveNumber, iterMap } from "../../lib/utils";
import { IfsConfig, RedmineConfig } from "../../config";
import { redmineClient } from "../ts/apis/redmineClient";
import { ifsClient } from "../ts/apis/ifsClient";
import TimesheetDay from "./TimesheetDay.vue";
import { iterFind } from "../../lib/utils";
import { clickupClient } from "../ts/apis";
import { CacheKeys, getOrSaveFromCache, saveToCache } from "../ts/utils";
import { useEventListener } from "../hooks/useEventListener";

type UpdateTimesheetItem = Partial<TimesheetItem> & Pick<TimesheetItem, "date" | "taskId">;


const tableData = ref<TimesheetDayItem[]>([]);
const buttonsOffset = ref<number>(0);
const teamData = ref<ClickTeam[]>([]);
const selectedTeam = ref<number>();
const teamDataSelect = computed(() => {
	return teamData.value.map(x => ({
		key: x.id,
		value: x.name
	}));
});

const affix = ref<typeof ElAffix>();

const activityData = ref<RMApiActivity[]>([]);
const selectedActivity = ref<number>();
const activityDataSelect = computed(() => {
	return activityData.value.map(x => ({
		key: x.id,
		value: x.name,
	}));
});

const loading = ref(true);

const dateRange = ref<DateRange>(dateWeekRange(new Date()));

const allTableData = computed<TimesheetDayItem[]>(() => {
	const data = tableData.value;
	const days = [
		...dateDaysIter(dateRange.value)
	];

	return days.map(d => {
		const found = data.find(x => dateIsSame(x.date, d));

		if (found) {
			return found;
		}

		return {
			id: formatDateSql(d),
			date: d,
			items: [],
		};
	});
});

const rangeFormatted = computed(() => {
	const { begin, end } = dateRange.value;
	if (!begin || !end) {
		return 'Not selected';
	}
	return formatDateSql(begin) + ' - ' + formatDateSql(end);
});

const user = ref<ClickUser>();

const dialogVisible = ref(false);
const selectedTask = ref<TimesheetTask | null>(null);

const selectedTeamId = computed(() => getPositiveNumber(selectedTeam.value, undefined));

useEventListener(window, "resize", function () {
	updateButtonsOffset();
	updateAffix();
});

onMounted(async () => {
	user.value = await apiResolveOrAlert(
		clickupClient.getCurrentUser(),
		undefined
	);

	teamData.value = await apiResolveOrAlert(clickupClient.getTeams(), []);
	selectedTeam.value = teamData.value.length && teamData.value[0].id || undefined;

	activityData.value = await apiResolveOrAlert(redmineClient.getActivities(), []);
	selectedActivity.value = activityData.value.length && await getOrSaveFromCache(CacheKeys.RM_ACTIVITY, () => activityData.value[0].id || undefined)();
	// dateRange.value = [dateStartOfWeek(new Date()), dateEndOfWeek(new Date())];

	updateButtonsOffset();
});

function changeActivity(id: number | undefined) {
	selectedActivity.value = id;
	console.log('activity changed', id);
	if (id === undefined) {
		return;
	}

	saveToCache(CacheKeys.RM_ACTIVITY, id)();
}



watch([selectedTask, dialogVisible], ([newTask, newVisbile]) => {
	if (newTask === null && newVisbile === true) {
		dialogVisible.value = false;
		console.log('reset dialog visible');
	} else if (newVisbile === false && newTask !== null) {
		selectedTask.value = null;
		console.log('reset selected task');
	}

	console.log('change', newTask, newVisbile);
});

watch([dateRange, selectedTeamId], ([date, teamId]) => {
	loadTimesheets(teamId, date);
});

function resetTimesheetHours(items: Iterable<TimesheetItem>, { begin, end }: DateRange, type: TimesheetType) {
	for (const item of items) {
		if (!dateInInterval(item.date, { begin, end })) {
			continue;
		}

		if (type === "ALL" || type === "RPTR") {
			item.reportHours = DurationTime.zero();
			item.reportHoursOld = DurationTime.zero();
			item.reportHoursChanged = false;
		}
		if (type === "ALL" || type === "RM") {
			item.redmineHours = DurationTime.zero();
			item.redmineHoursOld = DurationTime.zero();
			item.redmineHoursChanged = false;
		}
	}
}

async function loadIfsTimesheetHours({ begin, end }: Partial<DateRange>) {
	if (!begin || !end) {
		return;
	}

	const data = tableData.value.filter(x => dateInInterval(x.date, { begin, end }));

	if (!data.length) {
		return;
	}

	const params = {
		start: begin,
		end,
	};

	const summarizer = totalDayHoursSummarizer<ReportTimesheetItem>(x => x.date, x => x.reportHours);

	const ifsTimesheetHours: ReportTimesheetItem[] | null = await apiResolveOrAlert(loadReportTimesheetItems(params), null);

	if (ifsTimesheetHours) {
		resetTimesheetHours(getTimesheetsIterator(data), { begin, end }, "RPTR");
	}

	if (ifsTimesheetHours && ifsTimesheetHours.length) {
		for (const ifsItem of ifsTimesheetHours) {
			summarizer.add(ifsItem);

			const iterator = getTimesheetsIterator(data);

			for (const x of iterator) {
				if (!(dateIsSame(x.date, ifsItem.date) && x.ifsTaskId === ifsItem.ifsTaskId)) {
					continue;
				}

				if (x) {
					x.reportHours = addDuration(ifsItem.reportHours, x.reportHours);
					x.reportHoursOld = new DurationTime(x.reportHours);
					x.reportHoursChanged = false;
				}
			}
		}
	}

	const attendanceHours = await apiResolveOrAlert(loadAttendanceHours(params), []);
	const employeeDays = await apiResolveOrDefault(loadEmployeeDayInfo(params), []);

	for (const day of data) {
		day.totalReportHours = summarizer.result(day.date);

		const attendance = attendanceHours.find(x => dateIsSame(x.date, day.date));

		if (attendance) {
			day.attendanceHours = attendance.attendanceHours;
		}

		const dayState = employeeDays.find(x => dateIsSame(x.date, day.date))?.status;

		day.reportState = getReportState(dayState);
	}

}

function getReportState(status: IfsEmployeeDayStatus | undefined): TimesheetDayState {
	switch (status) {
		case "INWORK":
			return "OPENED";

		default:
			return "CONFIRMED";
	}
}

async function loadRedmineTimesheetHours({ begin, end }: Partial<DateRange>) {

	if (!begin || !end) {
		return;
	}

	const data = tableData.value;

	if (!data) return;

	const rmTimesheets = loadRedmineTimesheetItems({
		start: begin,
		end
	});

	const redmine: RMApiTimesheetHours[] | null = await apiResolveOrAlert(rmTimesheets, null);

	if (!redmine) {
		return;
	}

	resetTimesheetHours(getTimesheetsIterator(data), { begin, end }, "RM");

	const summarizer = totalDayHoursSummarizer<RMApiTimesheetHours>(x => x.date, x => x.duration);

	for (const rm of redmine) {
		summarizer.add(rm);

		const iter = getTimesheetsIterator(data);
		const found = iterFind(iter, ts => ts.redmineTaskId === rm.issueId && dateIsSame(ts.date, rm.date));

		if (!found) continue;

		found.redmineHours = addDuration(found.redmineHours, rm.duration);
		found.redmineHoursOld = found.redmineHours;
		found.redmineHoursChanged = false;
	}

	for (const day of data) {
		day.totalRedmineHours = summarizer.result(day.date);
	}
}

function totalDayHoursSummarizer<T>(dayProp: (i: T) => Date, durationProp: (i: T) => DurationTime | undefined) {

	const totalDayHours: Record<string, DurationTime> = {};

	function add(item: T) {
		const day = formatDateSql(dayProp(item));
		totalDayHours[day] = addDuration(durationProp(item), totalDayHours[day]);
	}

	return {
		add,
		result: (date: Date): DurationTime | undefined => {
			const day = formatDateSql(date);
			return totalDayHours[day];
		}
	}
}

async function loadTimesheets(
	teamId: number | undefined,
	{ begin, end }: Partial<DateRange>
): Promise<void> {
	loading.value = true;
	try {
		const userId = user.value?.id;
		if (!begin || !end || !teamId || !userId) {
			if (!teamId) {
				tableData.value = [];
			}
			return;
		}

		const timesheets = await apiResolveOrAlert(clickupClient.getTimesheetsHours({
			userId,
			teamId,
			start: begin,
			end,
		}), []);

		tableData.value = groupTimesheetsByDay(timesheets);

		loadIfsTimesheetHours({ begin, end });
		loadRedmineTimesheetHours(dateRange.value);
	} finally {
		loading.value = false;
	}
}

function handleTaskAssignSubmit(task: TimesheetTask | null) {
	if (!task) return;

	dialogVisible.value = false;

	const data = getTimesheetsIterator(tableData.value);

	if (!(data && task)) return;

	for (const ts of data) {
		if (ts.taskId !== task.id) continue;

		ts.taskName = task.name;

		if (task.redmineTaskId) {
			ts.redmineTaskId = task.redmineTaskId;
		}

		if (task.ifsTaskId) {
			ts.ifsTaskId = task.ifsTaskId;
		}
	}
}

async function handleChangeTaskName({ taskId, taskName }: { taskId: string, taskName: string }) {
	if (!(taskName && taskName.length)) {
		return;
	}

	const result = await apiResolveOrDefault(clickupClient.updateTask({
		taskId,
		data: {
			name: taskName
		}
	}), false);

	if (!result) {
		const task = await apiResolveOrDefault(clickupClient.getTaskById(taskId), null);

		if (task === null) {
			alert("Update task name failed.");
		} else {
			taskName = task.name;
		}
	}

	updateTaskName(taskId, taskName);
}

function updateTaskName(taskId: string, taskName: string) {
	const data = getTimesheetsIterator(tableData.value);

	for (const itm of data) {
		if (itm.taskId !== taskId) continue;

		itm.taskName = taskName;
	}
}

function getDayTimesheets(data: TimesheetDayItem[], date: Date): TimesheetItem[] {
	return data.find(x => dateIsSame(x.date, date))?.items || [];
}

function handleTaskAssignClose() {
	dialogVisible.value = false;
}

function handleRefresh() {
	loadTimesheets(selectedTeamId.value, dateRange.value);
}

async function handleSave() {
	const days = tableData.value;
	const activity = selectedActivity.value;
	ifsUpdateAndReloadTimesheets(days);

	if (activity) {
		rmUpdateAndReloadTimesheets(activity, days);
	}
}

async function rmUpdateAndReloadTimesheets(activity: number, days: TimesheetDayItem[]) {
	const updatedItems: UpdateRedmineTimesheetItem[] = await apiResolveOrAlert(rmUpdateTimesheets({
		activityId: activity,
		days,
	}), []);

	const [begin, end] = dateMinAndMax(updatedItems, x => x.date);

	if (!begin || !end) {
		return;
	}

	loadRedmineTimesheetHours({ begin, end });
}

async function ifsUpdateAndReloadTimesheets(days: TimesheetDayItem[]) {
	const updatedItems: UpdateReportTimesheetItem[] = await apiResolveOrAlert(updateIfsTimesheets(days), []);

	const [begin, end] = dateMinAndMax(updatedItems, x => x.date);

	if (!begin || !end) {
		return;
	}

	loadIfsTimesheetHours({ begin, end });
}

function updateIfsTimesheets(items: TimesheetDayItem[]): IfsApiResponse<UpdateReportTimesheetItem[]> {
	const params = {
		days: items
	};
	return ifsUpdateTimesheets(params);
}

function printTaskName(item: TimesheetItem) {
	return item.taskName || "*Unknown*";
}

function showDialog(task: TimesheetTask) {
	selectedTask.value = task;
	dialogVisible.value = true;
}

function updateButtonsOffset() {
	buttonsOffset.value = window.innerHeight - 50;
}

function updateAffix() {
	const aff = affix.value;
	if (!aff) {
		return;
	}

	aff.updated()
}

</script>

<style lang="scss" >
.el-tag--info {
	color: #c900c9;
	background-color: #ffd0ff;
}

.buttons {
	display: flex;
	justify-content: right;

	> * {
		margin-left: 10px;
	}
}
</style>